package com.logicbig.example;

import org.springframework.format.Formatter;

import java.text.ParseException;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Locale;

public class RFC1123LocalDateTimeFormatter
        implements Formatter<LocalDateTime> {

    private ZoneId targetZoneId;

    public RFC1123LocalDateTimeFormatter(ZoneId targetZoneId) {
        this.targetZoneId = targetZoneId;
    }

    @Override
    public LocalDateTime parse(String text, Locale locale) throws ParseException {
        return ZonedDateTime.parse(text, DateTimeFormatter.RFC_1123_DATE_TIME)
                .withZoneSameInstant(targetZoneId)
                .toLocalDateTime();
    }

    @Override
    public String print(LocalDateTime object, Locale locale) {
        return object.format(DateTimeFormatter.RFC_1123_DATE_TIME);
    }
}